<?php
/*
Plugin Name: Recent Posts From Each Category
Plugin URI: http://www.mindstien.com
Description: Display Recent Posts From Each Category on homepage or any other wordpress post / page using shortcode. You can include thumbnails (automatically generated), configure title length, excerpt length and much more...
Version: 1.0
Author: Chirag Gadara
Author URI: http://www.mindstien.com
License: GPL2
*/


add_shortcode('mycatlist','rpfec_catlist');

function rpfec_catlist($atts)
{
	/*
	if (!is_user_logged_in())
		return '';
	*/
	
	extract( shortcode_atts( array(
	      'cat' => 'all',
	      'posts' => 2,
	      'title_length' => 5,
	      'excerpt_length' => 20,
	      'readmore_text' => 'Read more',
	      'thumbnail' => 'yes',
	      'cat_title_tag' => 'h2',
	      'post_title_tag' => 'h2',
	      'width' => '200px',
	      'title_only' => 'no',
	      'cat_title_font_size' => '20px',
     ), $atts ) );
	
	if($cat == 'all')
	{
		$cat_args = array(
		'type'                     => 'post',
		'child_of'                 => 0,
		'parent'                   => '',
		'orderby'                  => 'name',
		'order'                    => 'ASC',
		'hide_empty'               => 1,
		'hierarchical'             => 0,
		'exclude'                  => '',
		'include'                  => '',
		'number'                   => '',
		'taxonomy'                 => 'category',
		'pad_counts'               => false );
		
		$temp = get_categories($cat_args);
		$cats = array();
		foreach ($temp as $t)
			$cats [] = $t->term_id;
	}
	else
		$cats = explode(',',$cat);
	
	$str = "";
	foreach ($cats as $cat)
	{
		//return "<pre>".print_r(get_category($cat),true)."</pre>";
		$cat_title = get_category($cat);
		
		
		// get category name and recent numbers of post with thumbnail.....
		 $args = array(
		'posts_per_page'  => $posts,
		'numberposts'     => $posts,
		'offset'          => 0,
		'category'        => $cat,
		'orderby'         => 'post_date',
		'order'           => 'DESC',
		'post_type'       => 'post',
		'post_status'     => 'publish',
		'suppress_filters' => true );
		
		$post2 = get_posts($args);
		
		$str .= "<div class='rpfec_box' style='width:".$width."'><center><$cat_title_tag class='cat_title' style='font-size:".$cat_title_font_size." !important'><a href='".get_category_link($cat)."'>".$cat_title->name."</a></$cat_title_tag></center>";
		$counter = 1;
		foreach($post2 as $post)
		{
		
			if($title_only=='yes')
			{
				$str .= "<div class='rpfec_inner'>$counter. <a href='".get_permalink($post->ID)."'>".mindstien_excerpt($post->post_title,$title_length)."</a></div>";
			}
			else
			{
				$thumb = '';
				if($thumbnail == 'yes')
					$thumb = mindstien_thumb( $post->ID);;
				$str .= "<div class='rpfec_inner'>
				<".$post_title_tag."><a href='".get_permalink($post->ID)."'>".mindstien_excerpt($post->post_title,$title_length)."</a></".$post_title_tag.">
				".$thumb."
				<p>".mindstien_excerpt($post->post_content,$excerpt_length,'')." <a href='".get_permalink($post->ID)."'>".__($readmore_text)."</a></p></div>";
			}
			$counter ++;
			
		}
		$str .= "</div>";
	}
	
	
	$str .="<div class='rpfec_clear'></div>";
	return '<div id="rpfec_container">'.$str.'</div>';
	//return "<pre>".print_r($categories,true)."</pre>";
}

function  mindstien_excerpt($data,$size=20,$read_more = '...')
{
	$data = strip_tags(strip_shortcodes($data));
	$temp = explode(' ',$data);
	$str = array();
	for($i=0;$i<$size;$i++)
		$str[] = $temp[$i];
	if(count($temp)<$size)
		return implode(' ',$str);
	else
		return implode(' ',$str).' '.__($read_more);
}

function mindstien_thumb($id){
	$find=false;
	if(function_exists('has_post_thumbnail'))
		if(has_post_thumbnail($id)){
			$plus=get_the_post_thumbnail($id,array('50px','50px'),array('class'=>'alignleft '));
			$find=true;
		}
	if(!$find){
		$post_thumbnail = mindstien_get_thumb_image($id);
		if(!empty($post_thumbnail))
			if($withlink=="yes")
				$plus='<a href="'.get_permalink().'">'.$post_thumbnail.'</a>';
			else
				$plus=$post_thumbnail;
	}
	return $plus;
}

function mindstien_get_thumb_image($id) {
	$content_post = get_post($id);
	$content = $content_post->post_content;
	
	$width = '50px';
	$align = 'left';
	$alt = '';
	$title = $content_post->post_title;
	
	$first_img = '';
	//extract image
	preg_match_all('~<img [^\>]*>~', $content, $matches);
	$first_image = $matches[0][0];
	//extract alt
	preg_match_all('~alt=[\'"]([^\'"]+)[\'"]~', $first_image, $matches);
	$alt = $matches[1][0];
	//extract title
	preg_match_all('~title=[\'"]([^\'"]+)[\'"]~', $first_image, $matches);
	$title = $matches[1][0];
	//extract src
	preg_match_all('~src=[\'"]([^\'"]+)[\'"]~', $first_image, $matches);
	$src=$matches[1][0];
	$srcorig=$matches[1][0];
	//last try, for images with src without quotes
	if(empty($src)){
		preg_match_all('~src=([^\'"]+) ~', $first_image, $matches);
		$src=$matches[1][0];
		$srcorig=$matches[1][0];
	}
	//find base image for jpg
	$imgtype=array("jpg","jpeg","gif","png");
	foreach($imgtype as $type){
		preg_match_all('~(\w*)-([0-9]*)x([0-9]*).('.$type.')~', $src, $matches);
		if(!empty($matches[1][0]))
			$src = substr($src,0,strrpos($src,'/')).'/'.$matches[1][0].'.'.$matches[4][0];
		$src = str_replace(".".$type,"-".get_option("thumbnail_size_w")."x".get_option("thumbnail_size_h").".".$type,$src);
	}
	
	$noimg=false;
	if(empty($src)){ //use the default image
		$noimg=true;
		
	}
	if($noimg==true){
		//not to show default? ok! nothing to show!
	}
	else {
		if(stripos($src,WP_CONTENT_URL)!==false){
			//the image is hosted on the blog
			$rest = str_replace(WP_CONTENT_URL,'',$src);
			if(!file_exists(realpath(".").'/wp-content'.$rest))
				if($regenerate=="yes"){
					//thumbnail not found and I'm allowed to regenerate
					$images =& get_children( array(
									'post_parent' => $id,
									'post_type' => 'attachment',
									'post_mime_type' => 'image',
									'numberposts' => -1,
									'post_status' => 'inherit',
									'post_parent' => null, // any parent
									'output' => 'object',
								) );
					foreach($images as $image)
						$ids[] = $image->ID;
					require_once(ABSPATH .'/wp-includes/post.php'); 
					require_once(ABSPATH .'/wp-admin/includes/image.php'); 
					foreach($ids as $idimg){
						$fullsizepath = get_attached_file($idimg);
						if(false === $fullsizepath || !file_exists($fullsizepath))
							die('-1');
						set_time_limit(60);
						wp_update_attachment_metadata( $idimg, wp_generate_attachment_metadata( $idimg, $fullsizepath));
					}
				}
			if(!file_exists(realpath(".").'/wp-content'.$rest))
				//thumbnail still not found: this means the image is below 150x150
				//or is a problem with regeneration; anyway, we use the original image
				$src=$srcorig;
		}
		else
			//the image is hosted outside the blog!
			$src=$srcorig;
		if($src==$srcorig)
			return '<img width="'.$width.'" src="'.$src.'" class="align'.$align.' wp-post-image tfe" alt="'.$alt.'" title="'.$title.'" />';
		else
			return '<img width="'.$width.'" height="'.$height.'" src="'.$src.'" class="align'.$align.' wp-post-image tfe" alt="'.$alt.'" title="'.$title.'" />';
	}
}

add_action('wp_head','rpfec_insert_style');

function rpfec_insert_style()
{
	?>
	<style>
	.rpfec_box
	{
		border:1px solid gray;
		float:left;
		margin:5px;
		padding:5px
	}
	.rpfec_clear
	{
		clear:both;
	}
	
	.rpfec_inner img {
		
		float: left;
		margin-bottom: 5px;
		margin-right: 5px;
	}
	#rpfec_container
	{
		width:100%;
		margin:0 auto;
	}
	.cat_title
	{
		margin:0px !important;
	}
	</style>
	<?php
}

function mindstien_load_scripts() {
	if ( !is_admin() ) {
		//wp_enqueue_script('jquery');
		wp_enqueue_script('masonry',plugins_url( 'js/jquery.masonry.min.js' , __FILE__ ),array( 'jquery' ),'',true);
		wp_enqueue_script('mindstien-script',plugins_url( 'js/script.js' , __FILE__ ),array( 'jquery' ),'',true);
	}
}
add_action( 'wp_enqueue_scripts', 'mindstien_load_scripts' );

?>